;/*
; * copy.asm
; *
; * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/
; *
; * This program is free software; you can redistribute it and/or
; * modify it under the terms of the GNU General Public License as
; * published by the Free Software Foundation version 2.
; *
; * This program is distributed "as is" WITHOUT ANY WARRANTY of any
; * kind, whether express or implied; without even the implied warranty
; * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; * GNU General Public License for more details.
; */

;****************************************************************************
;* Self Copy Algorithm for NOR Flash Programmer
;*
;****************************************************************************
;	.if $$isdefed("UBL_USE_NOR_BOOT")
	.sect ".selfCopy"

	.align 4
	.state32
	.global _c_copyUBL

;***************************************************************
;* FUNCTION DEF: _c_intDaVinci                                    
;***************************************************************
_c_copyUBL: .asmfunc

	;*------------------------------------------------------
	;* Initialize the TCM
	;*------------------------------------------------------
;	Read ITCM
	MRC p15, #00, R3, c9, c1, #1
	NOP
	MOV R0, #0x1;

;	Enable ITCM in case of AEMIF BOOT Only
	MCR p15, #00, R0, c9, c1, #1
	NOP
	NOP

;	Read Back the ITCM value to check the ITCM Enable function
	MRC p15, #00, R4, c9, c1, #1
	NOP
	NOP

	;*------------------------------------------------------
	;* Boot Strap UBL to IRAM
	;*------------------------------------------------------
	LDR		R0, _srcAddr
	LDR		R1, _destAddr
	LDR		R3, _count

_repeatCopy:
	LDR		R4, [R0], #4	   ; COPY A WORD OF DATA
	STR		R4, [R1], #4
	SUBS	R3, R3, #4	   
	BNE	_repeatCopy

	MOV		R1, #0x20
	MOV 	PC, R1

_srcAddr			.word           0x42000000
_destAddr			.word           0x00010020
_count			.word           0x00003800

;	.endif
