/*
 * pci.c
 *
 * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <bootloader.h>
#include <uart.h>

#ifdef UBL_USE_PCI_BOOT
#include <cslr_sys.h>
#include <cslr_pci.h>

extern Uint32 gEntryPoint;

void PCIBoot(void)
{
    Uint32 bootComplete = 0;
	int *entry_point = (int *)0x00017ffc;

    //===================================================
	// Clear Boot Complete Flag
	//===================================================
	CSL_FINS(CSL_SYS_0_REGS->BOOTSTAT, SYS_BOOTSTAT_BC, 0);

    UARTSendData(29,(Uint8 *) "\r\nBooting via PCI Boot Mode\r\n");

    //===================================================
	// Wait Boot Complete Flag become to '1'
	//===================================================
	bootComplete = 0;
	while(!bootComplete)
	{
		bootComplete = CSL_FEXT(CSL_SYS_0_REGS->BOOTSTAT, SYS_BOOTSTAT_BC);
        UARTSendData(1,(Uint8 *) ".");
	}

    UARTSendData(2,(Uint8 *) "\r\n");

    /* Set the entry point */
    gEntryPoint = *entry_point;
}

#endif
