/*
 * util.c
 *
 * Copyright (C) 2009 Texas Instruments Incorporated - http://www.ti.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/*******************************************************************************
 * FILE PURPOSE:    UBL Utility File
 *******************************************************************************
 * FILE NAME:       util.c
 *
 * DESCRIPTION:     UBL Utility File
 *
 ******************************************************************************/

/*
 * util.c:
 *
 * Author: Amit Chatterjee
 */

/* Local Strtucture */
#include <bootloader.h>

static int current_mem_loc = 0;

#pragma DATA_SECTION(internal_mem, ".internal_mem");
static char internal_mem[MAX_IMAGE_SIZE];

void *ubl_alloc_mem (int size)
{
	void *cPtr;

	if((current_mem_loc + size) > MAX_IMAGE_SIZE)
	{
		return 0;
	}

	cPtr = (void *) &internal_mem[current_mem_loc];
	current_mem_loc += size;

	return cPtr;
}
