/*
 * Copyright 2007 by Spectrum Digital Incorporated.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/*
 *  I2C EEPROM Header file [16 Kbytes - 24WC256]
 *
 */

#ifndef EEPROM_
#define EEPROM_

#ifdef __cplusplus
extern "C" {
#endif

#include "davincihd.h"
#include "davincihd_i2c.h"

/* ------------------------------------------------------------------------ *
 *  I2C Address                                                             *
 * ------------------------------------------------------------------------ */
#define EEPROM_I2C_ADDR             0x50

/* ------------------------------------------------------------------------ *
 *  EEPROM Memory Settings                                                  *
 * ------------------------------------------------------------------------ */
#define EEPROM_PAGE_SIZE            64
#define EEPROM_PAGE_SIZE_POW2       6
#define EEPROM_MAX_BURST_LEN        EEPROM_PAGE_SIZE

/* ------------------------------------------------------------------------ *
 *  Prototypes                                                              *
 * ------------------------------------------------------------------------ */
Int16 DAVINCIHD_EEPROM_init( );
Int16 DAVINCIHD_EEPROM_read( Uint32 src, Uint32 dst, Uint32 length );
Int16 DAVINCIHD_EEPROM_write( Uint32 src, Uint32 dst, Uint32 length );

#ifdef __cplusplus
}
#endif

#endif
