/*
 * Copyright 2007 by Spectrum Digital Incorporated.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/*
 *  LED header file
 *
 */

#ifndef LED_
#define LED_

#ifdef __cplusplus
extern "C" {
#endif

#include "davincihd.h"
#include "davincihd_i2c_gpio.h"

/* ------------------------------------------------------------------------ *
 *  LED Count                                                               *
 * ------------------------------------------------------------------------ */
#define NUM_LEDS                4

/* ------------------------------------------------------------------------ *
 *  I2C Address                                                             *
 * ------------------------------------------------------------------------ */
#define LED_I2C_ADDR            I2C_GPIO_GROUP_0

/* ------------------------------------------------------------------------ *
 *  Prototypes                                                              *
 * ------------------------------------------------------------------------ */
Int16 DAVINCIHD_LED_init  ( );
Int16 DAVINCIHD_LED_on    ( Uint16 number );
Int16 DAVINCIHD_LED_off   ( Uint16 number );
Int16 DAVINCIHD_LED_toggle( Uint16 number );

#ifdef __cplusplus
}
#endif

#endif
